/* eslint-disable no-console */
const postMessage = obj => {
  //console.log('browser_action: send message', obj);
  document.getElementsByTagName('iframe')[0].contentWindow.postMessage(JSON.stringify(obj), '*');
};

// Listen to message from child window
window.addEventListener('message', (e) => {
  let data;
  try {
    data = JSON.parse(e.data);
  } catch (err) { return; }

  if (e.origin !== 'http://lempod.com' && e.origin !== 'https://lempod.com' && e.origin !== 'http://app.lempod.com' && e.origin !== 'https://app.lempod.com' && e.origin !== 'http://localhost:9000' && e.origin !== 'https://apptest-0d01f777-653e-4c17-bc12-ed3e3b3261e6.lempod.com') {
    console.error('browser_action: Received a message from unknown origin', e.origin, data);
    return;
  }

  if (!data || !data.command) {
    console.error('browser_action: received a message without command', { origin: e.origin, data });
    return;
  }

  //console.log('browser_action: received message', data);

  if (data.command === 'cookie') {
    chrome.cookies.getAll({ url: 'https://www.linkedin.com/' }, cookieObjects => {
      const cookie = cookieObjects.map(c => `${c.name}=${c.value}`).join('; ');
      if (!cookie) return;

     // console.log('browser_action: get cookie', { cookie });
      postMessage({ command: 'cookie', cookie });
    });
  }
  if (data.command === 'currentPage') {
    chrome.tabs.query({ active: true, lastFocusedWindow: true }, tabs => {
      if (tabs && tabs.length) postMessage({ command: 'currentPage', currentPageUrl: tabs[0].url });
    });
  }
}, false);


let server;
chrome.management.getSelf(self => {
  server = self.installType === 'development' ? 'https://apptest-0d01f777-653e-4c17-bc12-ed3e3b3261e6.lempod.com' : 'https://app.lempod.com';

  const iframe = document.createElement('iframe');
  iframe.src = server;
  iframe.width = '100%';
  iframe.height = '565px';
  document.getElementById('mainPopup').appendChild(iframe);
});

localStorage.setItem('lempodOpened', (new Date()));
